note
	description: "Summary description for {MAIN_WINDOW}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	MAIN_WINDOW

inherit
	EV_TITLED_WINDOW
		redefine
			 initialize
		end

feature {NONE} -- Initialization

	initialize
   			--
		do
			Precursor
			create dialog
			dialog.extend (new_border_box)

			show_actions.extend (agent on_show)
		end

feature -- Basic operations

	prepare_to_show
		do
		end

feature {NONE} -- Event handler

	on_show
		do
			hide
			ev_application.do_once_on_idle (agent dialog.show_modal_to_window (Current))
		end

	on_exit
		do
			dialog.destroy
			destroy
			ev_application.destroy
		end

feature {NONE} -- Implementation

	new_border_box: EV_VERTICAL_BOX
		local
			box: like new_box; button: EV_BUTTON
		do
			create Result
			box := new_box
			Result.extend (box)
			Result.disable_item_expand (box)
			Result.set_border_width (5)
			Result.set_background_color (Color.Dark_green)
		end

	new_box: EV_VERTICAL_BOX
		do
			create Result
			Result.set_padding (5)
			Result.set_border_width (5)
			across components as widget loop
				Result.extend (widget.item)
				Result.disable_item_expand (widget.item)
			end
			Result.set_background_color (Color.white)
			Result.propagate_background_color
		end

	components: ARRAY [EV_WIDGET]
		local
			label: EV_LABEL; button: EV_BUTTON
		do
			create label.make_with_text ("Inner box")
			create button.make_with_text_and_action ("EXIT", agent on_exit)
			Result := << label, button >>
		end

	dialog: EV_UNTITLED_DIALOG

feature {NONE} -- Constants

	Window_title: STRING = "Test"

	Color: EV_STOCK_COLORS
		once
			create Result
		end

end
